(comment (herald global_defs))

; --------------------------------------------------------------------
; * Global Definitions of things *
; --------------------------------
; This file contains definitions of global constants used in various
;  simulator files.  These are defined as global constants so that
;  they are easy to change, they don't actually have to be global.
; --------------------------------------------------------------------
; * Stuff used to deal with automatically created node handlers.
; *  Used in file: NODES.T
; ------------------------

(defvar *si.map-node-handlers* nil)

; --------------------------------------------------------------------
; * Stuff used to define road mishaps.
; *  Used in file: LINKS.T
; ------------------------------------

(defvar *bumpy-day-broken-slow%* 0)
(defvar *bumpy-day-broken-medium%* 41)
(defvar *bumpy-day-broken-fast%* 55)
(defvar *bumpy-night-broken-slow%* 23)
(defvar *bumpy-night-broken-medium%* 67)
(defvar *bumpy-night-broken-fast%* 76)
(defvar *bumpy-day-dead-slow%* 0)
(defvar *bumpy-day-dead-medium%* 23)
(defvar *bumpy-day-dead-fast%* 41)
(defvar *bumpy-night-dead-slow%* 5)
(defvar *bumpy-night-dead-medium%* 41)
(defvar *bumpy-night-dead-fast%* 67)
(defvar *windy-day-rolled-slow%* 0)
(defvar *windy-day-rolled-medium%* 5)
(defvar *windy-day-rolled-fast%* 23)
(defvar *windy-night-rolled-slow%* 0)
(defvar *windy-night-rolled-medium%* 23)
(defvar *windy-night-rolled-fast%* 41)
(defvar *muddy-stuck-slow%* 75)
(defvar *muddy-stuck-medium%* 75)
(defvar *muddy-stuck-fast%* 75)
(defvar *enemy-day-slow-adjust* 150)
(defvar *enemy-day-medium-adjust* 0)
(defvar *enemy-day-fast-adjust* 50)
(defvar *enemies-at-mishap* 4)

; ---------------------------------------------------------------------
; * Stuff used to define enemy unit strengths.
; *  Used in file: ENEMY.T
; --------------------------------------------

(defvar *enemy-effectiveness* 25)
(defvar *maximum-new-enemies* 4)

